# Autogenerated wrapper script for z3_jll for i686-w64-mingw32
export libz3, z3

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "PATH"

# Relative path to `libz3`
const libz3_splitpath = ["bin", "libz3.dll"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libz3_path = ""

# libz3-specific global declaration
# This will be filled out by __init__()
libz3_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libz3 = "libz3.dll"


# Relative path to `z3`
const z3_splitpath = ["bin", "z3.exe"]

# This will be filled out by __init__() for all products, as it must be done at runtime
z3_path = ""

# z3-specific global declaration
function z3(f::Function; adjust_PATH::Bool = true, adjust_LIBPATH::Bool = true)
    global PATH, LIBPATH
    env_mapping = Dict{String,String}()
    if adjust_PATH
        if !isempty(get(ENV, "PATH", ""))
            env_mapping["PATH"] = string(PATH, ';', ENV["PATH"])
        else
            env_mapping["PATH"] = PATH
        end
    end
    if adjust_LIBPATH
        if !isempty(get(ENV, LIBPATH_env, ""))
            env_mapping[LIBPATH_env] = string(LIBPATH, ';', ENV[LIBPATH_env])
        else
            env_mapping[LIBPATH_env] = LIBPATH
        end
    end
    withenv(env_mapping...) do
        f(z3_path)
    end
end


"""
Open all libraries
"""
function __init__()
    global prefix = abspath(joinpath(@__DIR__, ".."))

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    global libz3_path = abspath(joinpath(artifact"z3", libz3_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libz3_handle = dlopen(libz3_path)
    push!(LIBPATH_list, dirname(libz3_path))

    global z3_path = abspath(joinpath(artifact"z3", z3_splitpath...))

    push!(PATH_list, dirname(z3_path))
    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ';')
    global LIBPATH = join(LIBPATH_list, ';')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

